// Copyright 2015, 2016, 2017 Ingo Steinwart
//
// This file is part of liquidSVM.
//
// liquidSVM is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as 
// published by the Free Software Foundation, either version 3 of the 
// License, or (at your option) any later version.
//
// liquidSVM is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Affero General Public License for more details.

// You should have received a copy of the GNU Affero General Public License
// along with liquidSVM. If not, see <http://www.gnu.org/licenses/>.



//**********************************************************************************************************************************

inline void Tbasic_svm::push_back_update(double delta, unsigned index, unsigned* counter)
{
	coefficient_delta[number_coefficients_changed] = delta;
	coefficient_changed[number_coefficients_changed] = index;
	number_coefficients_changed++;
	MM_CACHELINE_FLUSH(&number_coefficients_changed)
	
	if (counter != NULL)
		(*counter)++;
}


//**********************************************************************************************************************************


inline double Tbasic_svm::transform_label(double label)
{
	return (label - label_offset)/label_spread;
}

//**********************************************************************************************************************************


inline double Tbasic_svm::inverse_transform_label(double label)
{
	return label_spread * label + label_offset;
}
